## net.i2p.data
Class Signature

    java.lang.Object
      net.i2p.data.DataStructureImpl
          net.i2p.data.Signature

All Implemented Interfaces:
  DataStructure

public class Signature
extends DataStructureImpl

Defines the signature as defined by the I2P data structure spec. A signature is a 40byte Integer verifying the authenticity of some data using the algorithm defined in the crypto spec.

Author:
  jrandom

Field Summary
`static byte[]` `FAKE_SIGNATURE`
`static int` `SIGNATURE_BYTES`

Constructor Summary
`Signature()`
`Signature(byte[] data)`

Method Summary
`boolean` `equals(java.lang.Object obj)`
`byte[]` `getData()`
`int` `hashCode()`
`void` `readBytes(java.io.InputStream in)` Load up the current object with data from the given stream.
`void` `setData(byte[] data)`
`java.lang.String` `toString()`
`void` `writeBytes(java.io.OutputStream out)` Write out the data structure to the stream, using the format defined in the I2P data structure specification.

Methods inherited from class net.i2p.data.DataStructureImpl
`calculateHash, fromBase64, fromByteArray, read, toBase64, toByteArray`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### SIGNATURE_BYTES

    public static final int SIGNATURE_BYTES

See Also:
  Constant Field Values

### FAKE_SIGNATURE

    public static final byte[] FAKE_SIGNATURE

Constructor Detail

### Signature

    public Signature()

### Signature

    public Signature(byte[] data)

Method Detail

### getData

    public byte[] getData()

### setData

    public void setData(byte[] data)

### readBytes

    public void readBytes(java.io.InputStream in)
                   throws DataFormatException,
                          java.io.IOException

  Description copied from interface: `DataStructure`
  Load up the current object with data from the given stream. Data loaded this way must match the I2P data structure specification.

  Parameters:
    `in` - stream to read from
  Throws:
    `java.io.IOException` - if there was a problem reading the stream
    `DataFormatException` - if the data is improperly formatted

### writeBytes

    public void writeBytes(java.io.OutputStream out)
                    throws DataFormatException,
                           java.io.IOException

  Description copied from interface: `DataStructure`
  Write out the data structure to the stream, using the format defined in the I2P data structure specification.

  Parameters:
    `out` - stream to write to
  Throws:
    `java.io.IOException` - if there was a problem writing to the stream
    `DataFormatException` - if the data was incomplete or not yet ready to be written

### equals

    public boolean equals(java.lang.Object obj)

### hashCode

    public int hashCode()

### toString

    public java.lang.String toString()